#include <stdio.h>

unsigned int shl(unsigned int a, unsigned int b)
{
  if(b==32)
    return 0;
  
  return (a<<b);
}



unsigned int inverse(unsigned int a, unsigned int b)
{
  unsigned int x;
  unsigned int res;
  unsigned int bit;
  
  x=a;
  res=1;
  
  for(bit=1; bit<b; bit++)
  {
    if(x&(shl(1,bit)))
    {
      x+=shl(a,bit);
      res+=shl(1,bit);
    }
  }
  
  return res&(shl(1,b)-1);
}


int main()
{
  unsigned int a, b, c, k, aa, bb, cc, mask;

  while(1)
  {
    scanf("%u %u %u %u ", &a, &b, &c, &k);
    if(!a && !b && !c && !k)
      break;
    
    mask=shl(1,k)-1;
    
    a=(b-a)&mask;
    b=c;
    
    while(!(a&1) && !(b&1) && k)
    {
      a>>=1;
      b>>=1;
      k--;
    }
    
    if(!a)
      printf("0\n");
     else
    if(!(b&1))
      printf("FOREVER\n");
     else
    {
      mask=shl(1,k)-1;
      
      printf("%u\n", (inverse(b, k)*a)&mask);
    }
  }
  
  return 0;
}
